<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>What is the models repository?</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20080122;13345000">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20080122;13345000">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>What is the models
repository?</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>A place for large
sample models</I></FONT></FONT></H2>
<P><I>Model Driven Engineering</I> (MDE) is based on metamodels. For
MDE developers, the daily work consists in models manipulation. The
models a developer can design himself are generally small and more or
less &laquo;&nbsp;toy&nbsp;&raquo; models. In order to validate
transformations and other modelling tools code, there is a need of
large and exhaustive models.</P>
<P>As a model is useless without informations about its concerns and
contents, we specifically look after the data attached to each model.
The OpenEmbeDD Model Repository defines a dedicated set of data
designed using the <A HREF="http://dublincore.org/">DublinCore</A>
Metadata Initiative. You can find more details about the metadata
structure below in this chapter.</P>
<P>Main part of the models are under OpenSource licenses, and you can
get the license of a desired model on the repository web page
(<A HREF="http://openembedd-rep.gforge.inria.fr/">http://openembedd-rep.gforge.inria.fr</A>).</P>
<P>The easier way to get a sample model is to use SVN/Subversion
checkout. Within OpenEmbeDD platform, it is even easier with the
Subclipse plug-in (see <A HREF="http://openembedd.org/Download#platformdevsplugin">OpenEmbeDD
DEV tools</A>). After have parametrized the SVN of the repository,
choose the project of the desired model and check it out.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Tree &amp; names
policy</I></FONT></FONT></H2>
<P>For organisation needs, we design the repository on strict
structural and naming conventions, in order to operate automated data
extraction (for web page) and facilitate information accessibility
for visitors.</P>
<P>Each <B>metamodel</B> (like UML2) has its own Eclipse project,
which is named:</P>
<P>	<FONT FACE="Courier">org.openembedd.</FONT>&lt;metamodel&gt;<FONT FACE="Courier">.samples</FONT></P>
<P>For example, the UML models must be stored into an Eclipse project
named:</P>
<P>	<FONT FACE="Courier">org.openembedd.uml2.samples</FONT></P>
<P>Sample models which concern only a well identified part of the
metamodel can be stored in a separed project with the same naming
constraint, like the UML statecharts part:</P>
<P>	<FONT FACE="Courier">org.openembedd.uml2.statecharts.samples</FONT></P>
<P>Rem: as many real-word models embedd multiple parts of a
metamodel, there will be few separated sample projects. If the number
of samples for a metamodel makes project too large, some models could
be splitted into domains, like
<FONT FACE="Courier">org.openembedd.uml2.software.design.samples</FONT>.</P>
<P>Inside those projects, we consider each &laquo;&nbsp;sample&nbsp;&raquo;
as a (possible collection of) model(s). Each sample must be put in
its own directory. The directory name is free as soon as it respects
alphanumeric use of coding conventions (no dot, no exotic nor
accentuated characters,...). This name must be related with the model
contents (every directory in the repository projects is about a model
so do not use &laquo;&nbsp;model&nbsp;&raquo; in the directory name).</P>
<P>Inside the directory, only one file is mandatory: the metadata
file, which must have the <FONT FACE="Courier"><FONT SIZE=2><I><B>.dublincore</B></I></FONT></FONT>
extension (the main name is free under the same conditions than the
directory). Users will expect a &laquo;&nbsp;doc&nbsp;&raquo; sub
directory to find some informations about the model(s).</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Models metadata</I></FONT></FONT></H2>
<P>We decided to use the <A HREF="http://dublincore.org/">DublinCore</A>
metadata standard for OpenEmbeDD Models Repository samples
information. All DublinCore elements are optional and may be
repeated, which means that your are free to not fill some
informations at all, but we hope you try to give as many significant
informations as you can about the samples you deposit.</P>
<P>DublinCore elements used in the Repository:</P>
<UL>
	<LI><P><B>Title</B> [MANDATORY]: an free expressive name of the
	sample. One qualifier is available: <I>Alternative</I> (any form of
	the title used as a substitute or an alternative to the formal
	title). We will use the first title without alternative qualifier as
	the main title of the metadata.</P>
	<LI><P><B>Subject</B> [MANDATORY]: the topic of the content of the
	sample. It must be keywords in the  repository case, for indexation
	&amp; search purposes.</P>
	<LI><P><B>Description</B> [MANDATORY]: best practice recommandation
	is to use full sentencies. This element would be displayed to users
	on the web page. Two kind of qualifiers are possible: <I>Abstract</I>
	(if you already have a written abstract for the sample) and
	<I>TableOfContents</I> (to use for listed content, as sentencies are
	expected in the main <I>Description</I>).</P>
	<LI><P><B><I>Type</I></B> [MANDATORY]: the nature of the content in
	the ressource. The value describe the detailed type of one kind of
	model contained in the sample (ie: &laquo;&nbsp;UML2 statecharts
	diagram&nbsp;&raquo;). The metamodelVersion attribute give the
	metamodel these models are built on and its version number (in order
	to know if the sample works on a given platform or not).</P>
	<LI><P><B>Relation</B> : different kind of relations (refinements)
	can be registered. You must describe the related ressource and
	choose the closest kind of relation for the <I>refinement</I>
	attribute. If the sample or a model of the sample is not stored on
	the OpenEmbeDD Model Repository, put here its URI, with the <I>Requires</I>
	qualifier.</P>
	<LI><P><B>Creator</B> [MANDATORY]: information about the person or
	entity who created the sample model (name, email, company name, web
	site). It is the initial author or designer of the content.</P>
	<LI><P><B>Coverage</B> : the extent or scope of the sample. For the
	repository samples, it is the related metamodel (like UML2,
	Fiacre,...). At least, one coverage item is required, but you can
	put more (for complex samples which use multiple metamodels). Rem:
	we do not use the two DublinCore refinements (<I>spatial</I> and
	<I>temporal</I>).</P>
	<LI><P><B>Publisher</B> : the person or entity who make the sample
	publicly available [low interest in the models repository case]. If
	it is the same entity as the <I>Creator</I>, do not use <I>Publisher</I>
	element.</P>
	<LI><P><B>Contributor</B> : a person or entity who adds some
	contents to the sample or extends it. Same recommendations than
	<I>Creator</I>. If you create a new sample with some stuff from
	another sample, you become the <I>Creator</I> and the other sample
	<I>Creator</I> become <I>Contributor</I> of yours. A contribution
	can be presented in an additional <I>Description</I>.</P>
	<LI><P><B>Rights</B> [MANDATORY]: information about rights concerns
	of the sample, like Intellectual Property Rights, Copyright,
	licensing,... DublinCore proposes two refinements: <I>AccessRights</I>
	(information about who can access to the resource) and <I>License</I>
	(the legal document which tells what it is possible to do with the
	ressource, possibly an URL to the public document). It is a very
	IMPORTANT information: <B>the license of the sample is mandatory</B>
	for OpenEmbeDD Models Repository (permission to enhance the sample
	depends on the license).</P>
	<LI><P><B>Date</B> [MANDATORY]: a date corresponding to a event in
	the life of the sample. Different kind of refinements can be
	registered. You must enter the date and choose the closest kind of
	date for the <I>refinement</I> attribute. We have interest on
	<I>Created</I> and <I>Modified</I> dates.</P>
	<LI><P><B>Format</B> [MANDATORY]: describe the physical kind of the
	ressource. In our case, it is intersting to give informations about
	the way models are stored (extensions,...). Two qualifiers: <I>Extend</I>
	(the size or duration of ressource) and <I>Medium</I> (specific
	physical carrier of the ressource, like when the ressource is only
	available on DVD).</P>
	<LI><P><B>Identifier</B> : can be instance of a formal
	identification system like URI or ISBN number [low interest in the
	models repository case].</P>
	<LI><P><B>Language</B> : information about the language the sample
	is written in.</P>
</UL>
<P>With respect to DublinCore <I>One-to-One Principle</I>, the
informations inside a sample metadata must concern directly the
current sample version, and must be updated as soon as needed by
changes made upon the sample model(s).</P>
<P>According to DublinCore <I>Dumb-Down Principle</I>, the main
informations must be understandable without qualifiers refinements
(if refined). Main metadata elements must be fullfilled before using
any refinement. For example, the <I>Description</I> element must give
users a view on sample contents (or keywords) despite you join an
<I>Abstract</I> to the description.</P>
<P><B>DEV-note</B>: the use of enumeration for some elements value
has a side effect on the metadata model validation. In the generated
editor, all attributes which type is an enumeration are setted with
the first member of the enumeration as default value. It implies that
they are never seen as &laquo;&nbsp;unset&nbsp;&raquo; by the
validator (when EString attributes with a [1..1] multiplicity are
rejected if they are empty string). So enumerated attributes must be
seen as facilities for users and limitations but not as effective
constraints.</P>
</BODY>
</HTML>